<template>
  <div class="view-table-content">
    <div class="view-dataSpecies-left">
      <MenuTree :currentNodeKey="currentNodeKey" nodeKey="id" :treedata="menuTreeData" @TreeNodeclick="treeNodeClick" v-bind="treeObj"> </MenuTree>
    </div>
    <div class="view-dataSpecies-right">
      <div class="view-dataType-title">
        <div class="view-dataType-title-btn">
          <el-button type="success" @click="openDialog()" :disabled="!(currentNode.type == 1 && currentNode.children.length == 0)">新增</el-button>
          <el-button type="warning" @click="remove(tableCheckItems)" :disabled="tableCheckItems.length == 0">删除</el-button>
        </div>
        <div class="view-dataType-title-search">
          <el-input placeholder="请输入架次号" v-model="keyWordData" class="input1">
            <el-button slot="append" icon="el-icon-search" @click="searchClick" :disabled="!(currentNode.type == 1 && currentNode.children.length == 0)"></el-button>
          </el-input>
        </div>
      </div>
      <div class="view-dataType-table">
        <LTable ref="table" @selection-change="selection" :defaultFetch="false" :fetch="fetch" :columns="columns" :dataSource="tableData" :options="options" :pagination="tableRequset"></LTable>
      </div>
      <!-- 添加或修改预处理对话框 -->
      <el-dialog :title="dialogTitle" :visible.sync="dialogVisible" width="1000px" :before-close="handleClose">
        <el-form ref="executeForm" :model="executeForm" label-width="80px">
          <el-row>
            <el-col :span="8">
              <el-form-item label="编目" prop="aircraftId">
                <el-select v-model="executeForm.aircraftId" placeholder="请选择编目" @change="changeAircraftId(executeForm.aircraftId)">
                  <el-option v-for="item in aircaftCatalogAll" :key="item.aircaftCatalogId" :label="item.aircaftCatalogCode" :value="item.aircaftCatalogId"> </el-option>
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="模型类型" prop="modelType">
                <el-select v-model="executeForm.modelType" placeholder="请选择模型类型" @change="changeModelType(executeForm.modelType)">
                  <el-option v-for="item in algoTypeList" :key="item.id" :label="item.name" :value="item.id" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="模型" prop="modelId">
                <el-select v-model="executeForm.modelId" placeholder="请选择模型" @change="changeModelId(executeForm.modelId)">
                  <el-option v-for="item in modelList" :key="item.id" :label="item.name" :value="item.id" />
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>

          <el-form-item label="架次号" prop="sortieNo">
            <LTable ref="sortieNoTableRef" @current-change="sortieNoSelection" class="single-select-table" :columns="sortieNoColumns" :dataSource="sortieNoList" :options="sortieNoOptions" :pagination="SortieNoTableRequset"></LTable>
          </el-form-item>

          <el-form-item label="参数" prop="param">
            <el-input v-model="executeForm.param" type="textarea" :rows="2" placeholder="请输入参数" />
          </el-form-item>
          <el-form-item label="选择数据列" label-width="90px">
            <el-transfer v-model="transferRightData" :data="transferData" @change="changeColumnData"></el-transfer>
          </el-form-item>

          <!-- <el-form-item label="文件Id" prop="ossId">
            <el-input v-model="executeForm.ossId" placeholder="请输入文件Id" />
          </el-form-item> -->
        </el-form>

        <span slot="footer" class="dialog-footer">
          <el-button @click="handleClose">取 消</el-button>
          <el-button type="primary" @click="submit">确 定</el-button>
        </span>
      </el-dialog>
      <el-dialog title="执行进度" :visible.sync="progressVisible" width="800px" :before-close="handleClose">
        <el-progress :text-inside="true" :stroke-width="24" :percentage="percentage" status="success"></el-progress>
      </el-dialog>
      <el-dialog title="结果展示" :visible.sync="resultVisible" width="1200px">
        <PlayBackChart :chartData="chartData" />
        <span slot="footer" class="dialog-footer">
          <el-button @click="resultVisible = false">取 消</el-button>
          <el-button type="primary" @click="resultVisible = false">确 定</el-button>
        </span>
      </el-dialog>
    </div>
  </div>
</template>

<script>
import { getPreProcessing, addPreProcessing, updatePreProcessing, removePreProcessing } from '@/api/als/preProcessing'
import { getColumnDataAPI, executePreProcessing, getOssIdPlaybackDataAPI } from '@/api/als/algorithm'
import { getAircaftCatalogAll } from '@/api/als/aircraft'
import { getAircaftCatalogTree } from '@/api/als/sideTree'
import { getDataImport } from '@/api/als/dataImport'
import { getModel } from '@/api/als/model'
import { deepClone, debounce } from '@/utils/index'
import PlayBackChart from '@/views/als/components/Charts/playBackChart.vue'

export default {
  name: 'PreProcessing',
  components: { PlayBackChart },
  data() {
    // 这里存放数据
    return {
      preResultRef: 'preResultRef',
      dialogTitle: '新增',
      dialogVisible: false,
      progressVisible: false,
      resultVisible: false,
      keyWordData: '',
      aircaftModelIdList: [],
      currentNodeKey: '',
      currentNode: {},
      menuTreeData: [],
      treeObj: {
        title: '所属机种',
        activityheight: '275px',
        searchIcon: false,
        configure: {
          children: 'children',
          label: 'label'
        }
      },
      typeTree: {
        children: 'children',
        label: 'label'
      },
      searchValue: '',
      columns: [
        { prop: 'id', label: '编号' },
        {
          prop: 'sortieNo',
          label: '架次号'
        },
        {
          prop: 'aircraftId',
          label: '编目',
          render: (h, params) => {
            const matchedItem = this.aircaftCatalogAll.find((item) => params.row.aircraftId.trim() === item.aircaftCatalogId.trim())
            if (matchedItem) {
              return h('span', matchedItem.aircaftCatalogCode)
            } else {
              return h('span', {}, '')
            }
          }
        },
        {
          prop: 'modelType',
          label: '模型类型',
          render: (h, params) => {
            const matchedItem = this.$enumData.agloModelList.find((item) => params.row.modelType === item.key)
            if (matchedItem) {
              return h('span', matchedItem.name)
            } else {
              return h('span', {}, '')
            }
          }
        },
        {
          prop: 'param',
          label: '参数'
        },
        {
          prop: 'columnData',
          label: '数据列'
        },
        // {
        //   prop: 'ossId',
        //   label: '文件Id'
        // },
        {
          prop: 'result',
          label: '结果'
        },
        {
          prop: 'status',
          label: '状态',
          render: (h, params) => {
            if (params.row.status == 0) {
              return h('span', { class: 'warning-state' }, '失败')
            } else {
              return h('span', { class: 'success-state' }, '成功')
            }
          }
        },
        {
          button: true,
          label: '操作',
          width: '240px',
          group: [
            {
              name: '查看',
              type: 'text',
              round: false,
              plain: false,
              onClick: (row, index, scope) => {
                this.checkResultList(row)
              }
            },
            {
              name: '执行',
              type: 'text',
              round: false,
              plain: false,
              onClick: (row, index, scope) => {
                this.executeAglo(row)
              }
            },
            {
              name: '删除',
              type: 'text',
              round: false,
              plain: false,
              onClick: (row, index, scope) => {
                this.remove([row])
              }
            }
          ]
        }
      ],
      sortieNoColumns: [
        {
          prop: 'sortieNo',
          label: '架次号'
        },
        {
          prop: 'source',
          label: '数据来源'
        },
        {
          prop: 'ossId',
          label: '文件Id'
        }
      ],
      options: {
        stripe: true, // 斑马纹
        mutiSelect: true, // 多选框
        index: false, // 显示序号， 多选则 mutiSelect
        loading: false, // 表格动画
        initTable: false, // 是否一挂载就加载数据
        border: true,
        height: 'calc(100vh - 300px)'
      },
      sortieNoOptions: {
        stripe: true, // 斑马纹
        mutiSelect: false, // 多选框
        index: true, // 显示序号， 多选则 mutiSelect
        loading: false, // 表格动画
        initTable: false, // 是否一挂载就加载数据
        border: true,
        height: '250px'
      },
      SortieNoTableRequset: {
        total: 0,
        pageIndex: 1,
        pageSize: 10,
        searchValue: ''
      },
      tableCheckItems: [],
      tableData: [],
      tableRequset: {
        total: 0,
        pageIndex: 1,
        pageSize: 10,
        searchValue: ''
      },
      form: {
        id: '',
        sortieNo: '',
        aircraftId: '',
        modelType: '',
        modelName: '',
        param: '',
        columnData: [],
        ossId: '',
        result: '',
        status: '',
        tenantId: '',
        version: '',
        delFlag: '',
        createBy: '',
        createTime: '',
        updateBy: '',
        updateTime: ''
      },
      executeForm: {
        sortieNo: '',
        aircraftId: '',
        ossId: '',
        modelId: '',
        param: '',
        columnData: []
      },
      debounceFn: debounce(this.fetch, 500),
      aircaftCatalogAll: [],
      transferData: [],
      algoTypeList: [
        { id: 1, name: '去噪' },
        { id: 2, name: '扩充' },
        { id: 3, name: '补全' }
      ],
      transferRightData: [],
      modelList: [],
      percentage: 0,
      sortieNoList: [],
      chartData: {
        title: '',
        legendData: [],
        xAxisData: [],
        yAxisData: [],
        seriesData: []
      }
    }
  },
  watch: {
    keyWord() {
      this.tableRequset.pageIndex = 1
      this.debounceFn()
    }
  },
  mounted() {
    this.getAircaftCatalogTreeAPI()
  },
  methods: {
    async getAircaftCatalogTreeAPI(params) {
      try {
        const { data } = await getAircaftCatalogTree(params)
        // await getAirConfiguration({})
        this.menuTreeData = data
        const getAircaftCatalogAllParams = {
          keyWord: '',
          aircaftModelIdList: []
        }
        const { data: data2 } = await getAircaftCatalogAll(getAircaftCatalogAllParams)
        this.aircaftCatalogAll = data2
        if (data.length) {
          this.currentNodeKey = data[0].id
          this.currentNode = data[0]
          this.aircaftModelIdList = this.getTreeLeafData(data[0]?.children)
            .map((e) => e.id)
            .toString()
          this.getPreProcessingAPI({ aircraftId: this.aircaftModelIdList })
        }
      } catch (error) {}
    },

    async removePreProcessingAPI(params) {
      try {
        const { code } = await removePreProcessing(params)
        if (code === 200) {
          this.$message({
            type: 'success',
            message: '操作成功!'
          })
          await this.getPreProcessingAPI({ aircraftId: this.aircaftModelIdList })
          this.handleClose()
        }
      } catch (error) {}
    },

    getTreeLeafData(list) {
      const newArr = []
      function getLeaf(data, arr) {
        data.forEach((e) => {
          if (e.type === 1) {
            arr.push(e)
          }
          if (e.children.length) {
            getLeaf(e.children, arr)
          }
        })
      }
      getLeaf(list, newArr)
      return newArr
    },

    async getPreProcessingAPI(params) {
      if (this.$refs.table) this.$refs.table.clearSelection()
      const { keyWord } = this
      const { pageSize, pageIndex } = this.tableRequset
      const {
        data: { list, total }
      } = await getPreProcessing({ pageSize, pageNum: pageIndex, ...params })

      this.tableData = list
      this.tableRequset.total = total
    },

    fetch() {
      this.getPreProcessingAPI({ aircraftId: this.aircaftModelIdList })
    },

    searchClick() {
      this.getPreProcessingAPI({ aircraftId: this.aircaftModelIdList, sortieNo: this.keyWordData })
    },

    async addPreProcessingAPI() {
      try {
        delete this.form.aircaftModelName
        const { code } = await addPreProcessing({ ...this.form })
        if (code === 200) {
          this.$message({
            type: 'success',
            message: '操作成功!'
          })
          this.getPreProcessingAPI({ aircraftId: this.aircaftModelIdList })
        }
      } catch (error) {}
    },

    async updatePreProcessingAPI() {
      try {
        const { code } = await updatePreProcessing({ ...this.form })
        if (code === 200) {
          this.$message({
            type: 'success',
            message: '操作成功!'
          })
          this.getPreProcessingAPI({ aircraftId: this.aircaftModelIdList })
        }
      } catch (error) {}
    },

    treeNodeClick(data) {
      this.$refs.table.clearSelection()
      this.currentNodeKey = this.executeForm.aircraftId = data.id
      this.currentNode = data
      this.aircaftModelIdList = this.getTreeLeafData(data.children.length ? data.children : [data])
        .map((e) => e.id)
        .toString()
      this.getPreProcessingAPI({ aircraftId: this.aircaftModelIdList })
    },

    openDialog() {
      this.executeForm.aircraftId = this.currentNodeKey
      if (this.executeForm.aircraftId !== '') {
        this.changeAircraftId(this.executeForm.aircraftId)
      }
      this.dialogTitle = '新增'
      this.dialogVisible = true
    },

    handleClose() {
      this.dialogVisible = false
      this.transferRightData = []
      this.$refs.sortieNoTableRef.clearSelection()
      this.executeForm = {
        sortieNo: '',
        aircraftId: '',
        ossId: '',
        modelId: '',
        param: '',
        columnData: []
      }
    },

    handUpdate(row) {
      this.dialogTitle = '编辑'
      this.form = deepClone(row)
      this.dialogVisible = true
    },

    changeColumnData(value) {
      const data = []
      this.transferData.forEach((item) => {
        value.forEach((rightData) => {
          if (rightData === item.key) {
            data.push(item.label)
          }
        })
      })
      this.executeForm.columnData = data
    },

    changeModelId(modelId) {
      const modelColumnData = JSON.parse(
        this.modelList.find((item) => {
          return item.id === modelId
        }).columnData
      )

      const labelToKeyMap = this.transferData.reduce((acc, item) => {
        acc[item.label] = item.key
        return acc
      }, {})

      modelColumnData?.forEach((item) => {
        if (labelToKeyMap.hasOwnProperty(item)) {
          this.executeForm.columnData.push(item)
          this.transferRightData.push(labelToKeyMap[item])
        }
      })
    },

    async checkResultList(row) {
      if (row.status === '0') {
        this.$message({
          type: 'warning',
          message: '执行失败，无法查看结果!'
        })
        return
      }
      try {
        const { data } = await getOssIdPlaybackDataAPI(row.ossId)
        const { contentData, headData } = this.handleResultData(JSON.parse(data))
        this.chartData.legendData = headData
        for (var key in contentData) {
          if (key === '时间') {
            this.chartData.xAxisData = contentData['时间']
          } else {
            this.chartData.seriesData.push({
              name: key,
              type: 'line',
              data: contentData[key],
              connectNulls: true
            })
          }
        }
        this.resultVisible = true
      } catch (error) {}
    },
    handleResultData(resultData) {
      const headData = Object.keys(resultData[0])
      const contentData = {}
      headData.forEach((headItem) => {
        contentData[headItem] = []
      })
      // const contentData = Array.from({ length: headData.length }, () => [])
      resultData.forEach((item) => {
        for (var key in item) {
          contentData[key].push(item[key])
        }
      })
      return { contentData, headData }
    },
    executeAglo(row) {
      // this.executeVisible = true
      // this.agloForm.sortieNo = row.sortieNo
      // this.agloForm.aircraftId = row.aircraftId
    },
    async beginExecute() {
      this.progressVisible = true
      this.percentage += 1
      try {
        const res = await executePreProcessing(this.executeForm)
        this.percentage += 1
        const myTimer = setInterval(() => {
          if (res?.code === 200 && this.percentage == 100) {
            this.progressVisible = false
            clearInterval(myTimer)
            this.percentage = 0
            this.handleClose()
            this.$message({
              type: 'success',
              message: '执行成功!'
            })
            this.getPreProcessingAPI({ aircraftId: this.aircaftModelIdList })
          } else {
            this.percentage += 1
          }
        }, 30)
      } catch (error) {
        this.progressVisible = false
        clearInterval(myTimer)
        this.percentage = 0
      }
    },
    async changeModelType(type) {
      try {
        const {
          data: { list }
        } = await getModel({ type })
        this.modelList = list
      } catch (error) {}
    },

    async changeAircraftId(aircraftId) {
      try {
        const {
          data: { list, total }
        } = await getDataImport({ aircraftId })
        this.sortieNoList = list
        this.SortieNoTableRequset.total = total
      } catch (error) {}
    },

    async sortieNoSelection(val) {
      this.executeForm.ossId = val.ossId
      this.executeForm.sortieNo = val.sortieNo

      if (val.ossId) {
        const res = await getColumnDataAPI(val.ossId)
        if (res.code === 200) {
          this.transferData = []
          res.data.forEach((item, index) => {
            this.transferData.push({
              key: index,
              label: item
            })
          })
          if (this.executeForm.modelId) {
            this.changeModelId(this.executeForm.modelId)
          }
        }
      }
    },

    submit() {
      switch (this.dialogTitle) {
        case '编辑':
          this.updatePreProcessingAPI()
          this.handleClose()
          break
        case '新增':
          this.beginExecute()
          break
      }
    },

    selection(val) {
      this.tableCheckItems = val
    },

    remove(row) {
      this.$confirm('是否删除该数据', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      })
        .then(() => {
          this.removePreProcessingAPI(row.map((e) => e.id))
        })
        .catch(() => {})
    }
  }
}
</script>

<style lang="scss" scoped>
@import '../index.scss';
</style>
